<!DOCTYPE html>
<html>
<head>
<title>Threadit</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Latest compiled and minified CSS -->
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">

<!-- Optional theme -->
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css" integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
<!-- Latest compiled and minified JavaScript -->
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
<link href="style.css" rel="stylesheet">


<script src="http://ajax.aspnetcdn.com/ajax/knockout/knockout-2.2.1.js"></script>


</head>
<body>
    <div class="navbar navbar-inverse">
        <div class="navbar-header">
            <a class="navbar-brand" href="index.html">Threadit</a>
        </div>
    </div>

    <!--- MAIN CONTAINER START-->
    <div id="main" class="container">
        <div data-bind="with: threads().length">
        <table class="table table-striped table-hover">
            <thead class="thead-dark">
                <tr><td style="width: 1px;"></td><td><b>Name</b></td><td><b>Text</b></td><td><b>Options</b></td><td><b>Vote</b></td></tr>
            </thead>
            <tbody data-bind="foreach: $parent.threads">
                <tr>
                    <td style="vertical-align: middle;">
                        <span data-bind="text: plus" class="label label-success"></span>
                        <span data-bind="text: minus" class="label label-danger"></span>
                    </td>
                    <td data-bind="click: $parents[1].beginDetail" style="vertical-align: middle;"><p><b data-bind="text: name"></b></p><p data-bind="text: subthread"></p></td>
                    <td style="width: 50%;">
                        <p data-bind="text: text"></p>
                    </td>

                    <td>
                        <div class="btn-group-vertical">
                            <button data-bind="click: $parents[1].beginEdit" class="btn btn-default">Edit</button>
                            <button data-bind="click: $parents[1].remove" class="btn btn-warning">Delete</button>
                        </div>
                    </td>

                    <td>
                        <div class="btn-group-vertical">
                            <button data-bind="click: $parents[1].addPlus" class="btn btn-success">Vote Up</button>
                            <button data-bind="click: $parents[1].addMinus" class="btn btn-danger">Vote Down</button>
                        </div>
                    </td>

                </tr>
            </tbody>
        </table>

        <button data-bind="click: $parent.beginAdd" class="btn">Add Thread</button>
        </div>

    <!--- THREAD DETAIL START -->
    <div data-bind="with: details">
        <button data-bind="click: $parent.refreshThreads" class="btn btn-default">Back</button>
        <h3 data-bind="text: name"></h3>
        <button data-bind="text: plus" class="btn btn-success"></button>
        <button data-bind="text: minus" class="btn btn-danger"></button>
        <h4 data-bind="text: subthread"></h4>
        <p data-bind="text: text"></p>
    </div>
    <!--- THREAD DETAIL END -->


    </div>
    <!--- MAIN CONTAINER END-->

    <!--- ADD THREAD MODAL START-->
    <div id="add" class="modal fade" tabindex="=1" role="dialog" aria-labelledby="addDialogLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="addDialogLabel">Add Thread</h4>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="form-group">
                            <label class="col-form-label" for="inputThread">Thread</label>
                            <input data-bind="value: name" class="form-control" type="text" id="inputThread" placeholder="Thread name">
                        </div>
                        <div class="form-group">
                            <label class="col-form-label" for="inputThreadSubthread">Subthread</label>
                            <input data-bind="value: subthread" class="form-control" type="text" id="inputThreadSubthread" placeholder="Subthread">
                        </div>
                        <div class="form-group">
                            <label class="col-form-label" for="inputText">Text</label>
                            <textarea data-bind="value: text" class="form-control" type="text" id="inputText" placeholder="Text"></textarea>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button data-bind="click:addThread" class="btn btn-primary">Add Thread</button>
                    <button class="btn" data-dismiss="modal" aria-hidden="true">Cancel</button>
                </div>
            </div>
        </div>

    </div>
    <!--- ADD THREAD MODAL END-->

    <!--- EDIT THREAD MODAL START-->
    <div id="edit" class="modal fade" tabindex="=1" role="dialog" aria-labelledby="editDialogLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="editDialogLabel">Edit Thread</h4>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="form-group">
                            <label class="col-form-label" for="inputThread">Thread</label>
                            <input data-bind="value: name" class="form-control" type="text" id="inputThread" placeholder="Thread name">
                        </div>
                        <div class="form-group">
                            <label class="col-form-label" for="inputThreadSubthread">Subthread</label>
                            <input data-bind="value: subthread" class="form-control" type="text" id="inputThreadSubthread" placeholder="Subthread">
                        </div>
                        <div class="form-group">
                            <label class="col-form-label" for="inputText">Text</label>
                            <textarea data-bind="value: text" class="form-control" type="text" id="inputText" placeholder="Text"></textarea>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button data-bind="click:editThread" class="btn btn-primary">Update Thread</button>
                    <button class="btn" data-dismiss="modal" aria-hidden="true">Cancel</button>
                </div>
            </div>
        </div>

    </div>
    <!--- EDIT THREAD MODAL END-->


    <!--- LOGIN MODAL START-->
    <div id="login" class="modal fade" tabindex="=1" role="dialog" aria-labelledby="loginLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="loginLabel">Sign In</h4>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="form-group">
                            <label class="col-form-label" for="inputUsername">Username</label>
                            <input data-bind="value: username" class="form-control" type="text" id="inputUsername" placeholder="Username">           
                        </div>
                        <div class="form-group">
                            <label class="col-form-label" for="inputPassword">Password</label>
                            <input data-bind="value: password" class="form-control" type="password" id="inputPassword" placeholder="Password">
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button data-bind="click: login" class="btn btn-primary" data-dismiss="modal" aria-hidden="true">Sign In</button>
                </div>
            </div>
        </div>
    </div>
    <!--- LOGIN MODAL END-->


    
    <script type="text/javascript">
    function ThreadsViewModel() {
        var self = this;
        self.threadsURI = 'http://threadit-threadit.7e14.starter-us-west-2.openshiftapps.com/threadit/api/v1.0/threads';

        self.threads = ko.observableArray();
        self.details = ko.observable();

        self.ajax = function(uri, method, data) {
            var request = {
                url: uri,
                type: method,
                contentType: "application/json",
                accepts: "application/json",
                cache: false,
                dataType: 'json',
                data: JSON.stringify(data),
                beforeSend: function (xhr) {
                    xhr.setRequestHeader("Authorization", 
                        "Basic " + btoa(self.username + ":" + self.password));
                },
                error: function(jqXHR) {
                    console.log("ajax error " + jqXHR.status);
                }
            };
            return $.ajax(request);
        }

        self.updateThread = function(thread, newThread) {
            var i = self.threads.indexOf(thread);
            self.threads()[i].uri(newThread.uri);
            self.threads()[i].name(newThread.thread_name);
            self.threads()[i].text(newThread.thread_text);
            self.threads()[i].subthread(newThread.thread_subthread);
            self.threads()[i].plus(newThread.thread_plus);
            self.threads()[i].minus(newThread.thread_minus);
            console.log(" " + newThread.uri );
        }

        self.beginAdd = function() {
            $('#add').modal('show');
        }

        self.beginDetail = function(thread){
            self.threads.removeAll();
            self.ajax(thread.uri(), 'GET').done(function(data) {
                self.details({
                    uri: ko.observable(data.thread.uri),
                    name: ko.observable(data.thread.thread_name),
                    text: ko.observable(data.thread.thread_text),
                    subthread: ko.observable(data.thread.thread_subthread),
                    minus: ko.observable(data.thread.thread_minus),
                    plus: ko.observable(data.thread.thread_plus)
                    });
                });
        }



        self.add = function(thread) {
                self.ajax(self.threadsURI, 'POST', thread).done(function(data) {
                    self.threads.push({
                        uri: ko.observable(data.thread.uri),
                        name: ko.observable(data.thread.thread_name),
                        text: ko.observable(data.thread.thread_text),
                        subthread: ko.observable(data.thread.thread_subthread),
                        minus: ko.observable(data.thread.thread_minus),
                        plus: ko.observable(data.thread.thread_plus)
                    });
                });
            }

        self.beginEdit = function(thread) {
            editThreadViewModel.setThread(thread);
            $('#edit').modal('show');
        }

        self.edit = function(thread, data) {
            self.ajax(thread.uri(), 'PUT', data).done(function(res) {
                self.updateThread(thread, res.thread);
            });
        }


        self.remove = function(thread) {
            self.ajax(thread.uri(), 'DELETE').done(function() {
                self.threads.remove(thread);
            });
        }

        self.addPlus = function(thread) {
            var i = self.threads.indexOf(thread);
            self.ajax(thread.uri(), 'PUT', {
                thread_plus: self.threads()[i].plus()+1,
            }).done(function(res) {
                self.updateThread(thread, res.thread);
            });
        }
        self.addMinus = function(thread) {
            var i = self.threads.indexOf(thread);
            self.ajax(thread.uri(), 'PUT', {
                thread_minus: self.threads()[i].minus()+1
            }).done(function(res) {
                self.updateThread(thread, res.thread);
            });
        }

        self.beginLogin = function() {
            $('#login').modal('show');
        }
        self.login = function(username, password) {
            self.username = username;
            self.password = password;
            self.refreshThreads();
        }

        self.refreshThreads = function(){
            if(self.threads.length != 0){
                self.threads.removeAll();   
            }
            
            self.details(null);
            self.ajax(self.threadsURI, 'GET').done(function(data) {
                for (var i = 0; i < data.threads.length; i++) {
                    self.threads.push({
                        uri: ko.observable(data.threads[i].uri),
                        name: ko.observable(data.threads[i].thread_name),
                        subthread: ko.observable(data.threads[i].thread_subthread),
                        text: ko.observable(data.threads[i].thread_text),
                        plus: ko.observable(data.threads[i].thread_plus),
                        minus: ko.observable(data.threads[i].thread_minus),
                    });
                }
            }).fail(function(jqXHR) {
                if (jqXHR.status == 403)
                    setTimeout(self.beginLogin, 500);
            });
        }

        self.beginLogin();
        
    }

    function AddThreadViewModel() {
        var self = this;
        self.name = ko.observable();
        self.subthread = ko.observable();
        self.text = ko.observable();

        self.addThread = function() {
            $('#add').modal('hide');
            threadsViewModel.add({
                thread_name: self.name(),
                thread_subthread: self.subthread(),
                thread_text: self.text()
            });
            self.name("");
            self.subthread("");
            self.text("");
        }
    }

    function EditThreadViewModel() {
        var self = this;
        self.name = ko.observable();
        self.subthread = ko.observable();
        self.text = ko.observable();

        self.setThread = function(thread) {
            self.thread = thread;
            self.name(thread.name());
            self.text(thread.text());
            self.subthread(thread.subthread());

            $('edit').modal('show');
        }
        self.editThread = function() {
            $('#edit').modal('hide');
            threadsViewModel.edit(self.thread, {
                thread_name: self.name(),
                thread_text: self.text(),
                thread_subthread: self.subthread()
            });
        }
    }

    function LoginViewModel() {
        var self = this;
        self.username = ko.observable();
        self.password = ko.observable();

        self.login = function() {
            $('#login').modal('hide');
            threadsViewModel.login(self.username(), self.password());
        }
    }




    var threadsViewModel = new ThreadsViewModel();
    var addThreadViewModel = new AddThreadViewModel();
    var editThreadViewModel = new EditThreadViewModel();
    var loginViewModel = new LoginViewModel();
 

    ko.applyBindings(threadsViewModel, $('#main')[0]);
    ko.applyBindings(addThreadViewModel, $('#add')[0]);
    ko.applyBindings(editThreadViewModel, $('#edit')[0]);
    ko.applyBindings(loginViewModel, $('#login')[0]);

    </script>
</body>
</html>